// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.internal.component.AbstractUITreeListbox;
import org.apache.myfaces.tobago.layout.Display;
import org.apache.myfaces.tobago.layout.Measure;
import org.apache.myfaces.tobago.internal.util.ArrayUtils;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.renderkit.MarginValues;
import org.apache.myfaces.tobago.renderkit.SpacingValues;
import org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.ArrayList;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/** 
 A tree data structure displayed as a set of list boxes.
  * UIComponent class, generated from template {@code component2.0.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.TreeListboxTagDeclaration}.
 */
public class UITreeListbox
    extends AbstractUITreeListbox implements SupportsMarkup {

  public static final String COMPONENT_TYPE = "org.apache.myfaces.tobago.TreeListbox";

  public static final String COMPONENT_FAMILY = "javax.faces.Data";

  private org.apache.myfaces.tobago.context.Markup currentMarkup;

  enum PropertyKeys {
    columnSpan,
    preferredWidth,
    horizontalIndex,
    selectable,
    required,
    preferredHeight,
    marginRight,
    top,
    currentWidth,
    maximumWidth,
    currentHeight,
    height,
    rowSpan,
    markup,
    display,
    minimumHeight,
    marginLeft,
    left,
    width,
    maximumHeight,
    marginBottom,
    verticalIndex,
    minimumWidth,
    marginTop,
  }

  public String getFamily() {
    return COMPONENT_FAMILY;
  }


  public java.lang.Integer getColumnSpan() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.columnSpan);
    if (value != null) {
      return value.intValue();
    }
    return 1;
  }

  public void setColumnSpan(java.lang.Integer columnSpan) {
    getStateHelper().put(PropertyKeys.columnSpan, columnSpan);
  }

  public org.apache.myfaces.tobago.layout.Measure getPreferredWidth() {
    Object object = getStateHelper().eval(PropertyKeys.preferredWidth);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getPreferredWidth(getFacesContext(), this) : Measure.ZERO;
  }

  public void setPreferredWidth(org.apache.myfaces.tobago.layout.Measure preferredWidth) {
    getStateHelper().put(PropertyKeys.preferredWidth, preferredWidth);
  }

  /**
  This attribute is for internal use only.

  */
  public java.lang.Integer getHorizontalIndex() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.horizontalIndex);
    if (value != null) {
      return value.intValue();
    }
    return null;
  }

  public void setHorizontalIndex(java.lang.Integer horizontalIndex) {
    getStateHelper().put(PropertyKeys.horizontalIndex, horizontalIndex);
  }

  /**
  Flag indicating whether or not this component should be render selectable items. Possible values are:
   <ul>
   <li><strong>single</strong> : a single section tree is rendered</li>
   <li><strong>multiLeafOnly</strong> : a multi section tree is rendered,
   only Leaf's are selectable</li>
   <li><strong>singleLeafOnly</strong> : a single section tree is rendered,
   only Leaf's are selectable</li>
   </ul>
  <br />Default: <code>single</code><br />Allowed Values: <code>single,multiLeafOnly,singleLeafOnly</code>
  */
  public java.lang.String getSelectable() {
    java.lang.String selectable = (java.lang.String) getStateHelper().eval(PropertyKeys.selectable);
    if (selectable != null) {
      return selectable;
    }
    return "single";
  }

  public void setSelectable(java.lang.String selectable) {
    getStateHelper().put(PropertyKeys.selectable, selectable);
  }

  /**
  Flag indicating that a value is required. If the value is an empty string a ValidationError occurs and a Error
   Message is rendered.
  <br />Default: <code>false</code>
  */
  public boolean isRequired() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.required);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setRequired(boolean required) {
    getStateHelper().put(PropertyKeys.required, required);
  }

  public org.apache.myfaces.tobago.layout.Measure getPreferredHeight() {
    Object object = getStateHelper().eval(PropertyKeys.preferredHeight);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getPreferredHeight(getFacesContext(), this) : Measure.ZERO;
  }

  public void setPreferredHeight(org.apache.myfaces.tobago.layout.Measure preferredHeight) {
    getStateHelper().put(PropertyKeys.preferredHeight, preferredHeight);
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginRight() {
    Object object = getStateHelper().eval(PropertyKeys.marginRight);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginRight(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMarginRight(org.apache.myfaces.tobago.layout.Measure marginRight) {
    getStateHelper().put(PropertyKeys.marginRight, marginRight);
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getTop() {
    Object object = getStateHelper().eval(PropertyKeys.top);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return null;
  }

  public void setTop(org.apache.myfaces.tobago.layout.Measure top) {
    getStateHelper().put(PropertyKeys.top, top);
  }

  /**
  This value will usually be set by the layout manager. It holds the current width computed by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getCurrentWidth() {
    Object object = getStateHelper().eval(PropertyKeys.currentWidth);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getWidth();
  }

  public void setCurrentWidth(org.apache.myfaces.tobago.layout.Measure currentWidth) {
    getStateHelper().put(PropertyKeys.currentWidth, currentWidth);
  }

  public org.apache.myfaces.tobago.layout.Measure getMaximumWidth() {
    Object object = getStateHelper().eval(PropertyKeys.maximumWidth);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMaximumWidth(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMaximumWidth(org.apache.myfaces.tobago.layout.Measure maximumWidth) {
    getStateHelper().put(PropertyKeys.maximumWidth, maximumWidth);
  }

  /**
  This value will usually be set by the layout manager. It holds the current height computed by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getCurrentHeight() {
    Object object = getStateHelper().eval(PropertyKeys.currentHeight);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getHeight();
  }

  public void setCurrentHeight(org.apache.myfaces.tobago.layout.Measure currentHeight) {
    getStateHelper().put(PropertyKeys.currentHeight, currentHeight);
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getHeight() {
    Object object = getStateHelper().eval(PropertyKeys.height);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getHeight(getFacesContext(), this) : Measure.ZERO;
  }

  public void setHeight(org.apache.myfaces.tobago.layout.Measure height) {
    getStateHelper().put(PropertyKeys.height, height);
  }

  public java.lang.Integer getRowSpan() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.rowSpan);
    if (value != null) {
      return value.intValue();
    }
    return 1;
  }

  public void setRowSpan(java.lang.Integer rowSpan) {
    getStateHelper().put(PropertyKeys.rowSpan, rowSpan);
  }

  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    Object object = getStateHelper().eval(PropertyKeys.markup);
    if (object != null) {
      return Markup.valueOf(object);
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    getStateHelper().put(PropertyKeys.markup, markup);
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Display getDisplay() {
    return (org.apache.myfaces.tobago.layout.Display) getStateHelper().eval(PropertyKeys.display);
  }

  public void setDisplay(org.apache.myfaces.tobago.layout.Display display) {
    getStateHelper().put(PropertyKeys.display, display);
  }

  public org.apache.myfaces.tobago.layout.Measure getMinimumHeight() {
    Object object = getStateHelper().eval(PropertyKeys.minimumHeight);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMinimumHeight(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMinimumHeight(org.apache.myfaces.tobago.layout.Measure minimumHeight) {
    getStateHelper().put(PropertyKeys.minimumHeight, minimumHeight);
  }

  public org.apache.myfaces.tobago.context.Markup getCurrentMarkup() {
    if (currentMarkup != null) {
      return currentMarkup;
    }
    return null;
  }

  public void setCurrentMarkup(org.apache.myfaces.tobago.context.Markup currentMarkup) {
    this.currentMarkup = currentMarkup;
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginLeft() {
    Object object = getStateHelper().eval(PropertyKeys.marginLeft);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginLeft(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMarginLeft(org.apache.myfaces.tobago.layout.Measure marginLeft) {
    getStateHelper().put(PropertyKeys.marginLeft, marginLeft);
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getLeft() {
    Object object = getStateHelper().eval(PropertyKeys.left);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return null;
  }

  public void setLeft(org.apache.myfaces.tobago.layout.Measure left) {
    getStateHelper().put(PropertyKeys.left, left);
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getWidth() {
    Object object = getStateHelper().eval(PropertyKeys.width);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getWidth(getFacesContext(), this) : Measure.ZERO;
  }

  public void setWidth(org.apache.myfaces.tobago.layout.Measure width) {
    getStateHelper().put(PropertyKeys.width, width);
  }

  public org.apache.myfaces.tobago.layout.Measure getMaximumHeight() {
    Object object = getStateHelper().eval(PropertyKeys.maximumHeight);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMaximumHeight(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMaximumHeight(org.apache.myfaces.tobago.layout.Measure maximumHeight) {
    getStateHelper().put(PropertyKeys.maximumHeight, maximumHeight);
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginBottom() {
    Object object = getStateHelper().eval(PropertyKeys.marginBottom);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginBottom(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMarginBottom(org.apache.myfaces.tobago.layout.Measure marginBottom) {
    getStateHelper().put(PropertyKeys.marginBottom, marginBottom);
  }

  /**
  This attribute is for internal use only.

  */
  public java.lang.Integer getVerticalIndex() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.verticalIndex);
    if (value != null) {
      return value.intValue();
    }
    return null;
  }

  public void setVerticalIndex(java.lang.Integer verticalIndex) {
    getStateHelper().put(PropertyKeys.verticalIndex, verticalIndex);
  }

  public org.apache.myfaces.tobago.layout.Measure getMinimumWidth() {
    Object object = getStateHelper().eval(PropertyKeys.minimumWidth);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMinimumWidth(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMinimumWidth(org.apache.myfaces.tobago.layout.Measure minimumWidth) {
    getStateHelper().put(PropertyKeys.minimumWidth, minimumWidth);
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginTop() {
    Object object = getStateHelper().eval(PropertyKeys.marginTop);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginTop(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMarginTop(org.apache.myfaces.tobago.layout.Measure marginTop) {
    getStateHelper().put(PropertyKeys.marginTop, marginTop);
  }

  public Object saveState(FacesContext context) {
    currentMarkup = null;
    return super.saveState(context);
  }

}